const std = @import("std");
const vk = @import("vulkan");

pub const device_extensions = [_][*:0]const u8{vk.extensions.khr_swapchain.name};

// Vertex data representation
pub const Vertex = struct {
    // Vertex position (x, y, z)
    pos: @Vector(3, f32),
};

pub const QueueFamilyIndices = struct {
    graphics_family: ?u32 = null,
    presentation_family: ?u32 = null,

    pub fn isValid(self: QueueFamilyIndices) bool {
        return self.graphics_family != null and self.presentation_family != null;
    }
};

pub const SwapchainDetails = struct {
    surface_capabilities: vk.SurfaceCapabilitiesKHR,
    formats: []vk.SurfaceFormatKHR,
    presentation_modes: []vk.PresentModeKHR,
};

pub const SwapchainImage = struct {
    image: vk.Image,
    image_view: vk.ImageView,
};
